Bug 654585 - speech-dispatcher cannot load modules, missing rpath
Summary: speech-dispatcher cannot load modules, missing rpath
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: speech-dispatcher
Version: 14
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: ---
Assignee: Peter Robinson
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 569531
TreeView+ depends on / blocked
 
Reported: 2010-11-18 10:37 UTC by Fernando Herrera
Modified: 2011-04-05 05:19 UTC (History)
5 users (show)

Fixed In Version: speech-dispatcher-0.7.1-5.fc13
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-04-05 05:18:30 UTC


Attachments (Terms of Use)

Description Fernando Herrera 2010-11-18 10:37:22 UTC
Trying to run speech-dispactcher fails because it cannot load their modules.

Running it with -D option gives this in the logs:

[Thu Nov 18 11:32:30 2010 : 170602] speechd: Speech Dispatcher Logging to file /home/fer/.speech-dispatcher/log//speechd.log
[Thu Nov 18 11:32:30 2010 : 170750] speechd: Initializing output module espeak with binary /usr/lib/speech-dispatcher-modules/sd_espeak and configuration /home/fer/.speech-dispatcher/conf//modules//espeak.conf
[Thu Nov 18 11:32:30 2010 : 170770] speechd: Output module is logging to file /home/fer/.speech-dispatcher/log//espeak.log
[Thu Nov 18 11:32:30 2010 : 171090] speechd: Module espeak loaded.
[Thu Nov 18 11:32:30 2010 : 171139] speechd: Trying to initialize espeak.
[Thu Nov 18 11:32:30 2010 : 171392] speechd: ERROR: Bad syntax from output module espeak 1
[Thu Nov 18 11:32:30 2010 : 171413] speechd: Couldn't load specified output module
....

[Thu Nov 18 11:32:30 2010 : 171485] speechd: Initializing output module festival with binary /usr/lib/speech-dispatcher-modules/sd_festival and configuration /home/fer/.speech-dispatcher/conf//modules//festival.conf
[Thu Nov 18 11:32:30 2010 : 171506] speechd: Output module is logging to file /home/fer/.speech-dispatcher/log//festival.log
[Thu Nov 18 11:32:30 2010 : 171795] speechd: Module festival loaded.
[Thu Nov 18 11:32:30 2010 : 171835] speechd: Trying to initialize festival.
[Thu Nov 18 11:32:30 2010 : 171984] speechd: ERROR: Bad syntax from output module festival 1
[Thu Nov 18 11:32:30 2010 : 172005] speechd: Couldn't load specified output module
....

and so on

looking at per-module log files I see the problem:
from festival.log:

: error while loading shared libraries: libsdaudio.so.2: cannot open shared object file: No such file or directory

and I get the same in the other modules.


running speech-dispatcher like this:

LD_LIBRARY_PATH=/usr/lib/speech-dispatcher/ speech-dispatcher -D

fixes the issue

Comment 1 Matthias Clasen 2011-02-21 01:00:16 UTC
I'm seeing this too. It makes orca unable to speak. Can we get this fixed ?

Comment 2 Rex Dieter 2011-03-11 19:04:09 UTC
I'm seeing this on f15-alpha too

Comment 3 Fernando Herrera 2011-03-11 19:41:50 UTC
spec file is removing rpath:

# Remove rpath as per https://fedoraproject.org/wiki/Packaging/Guidelines#Beware_of_Rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

and speechdispatched modules are relying on rpath as seen on modules/Makefile.am:

sd_flite_SOURCES = flite.c module_utils.c module_utils.h
sd_flite_LDFLAGS = @RPATH@ '$(spdlibdir)'
sd_flite_LDADD = -lsdaudio $(flite_kal) $(flite_basic) -lpthread -ldotconf @glib_libs@ @gthread_libs@

So, either we keep rpath for modules, or we install spdlibdir files on /usr/lib

Comment 4 Fedora Update System 2011-03-15 09:44:59 UTC
speech-dispatcher-0.7.1-4.fc13,dotconf-1.3-2.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-4.fc13,dotconf-1.3-2.fc13

Comment 5 Fedora Update System 2011-03-15 09:45:40 UTC
speech-dispatcher-0.7.1-4.fc14,dotconf-1.3-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-4.fc14,dotconf-1.3-2.fc14

Comment 6 Kevin Kofler 2011-03-15 10:31:38 UTC
This is NOT fixed in 0.7.1-4. See comment #3.

Comment 7 Rex Dieter 2011-03-15 13:25:21 UTC
Fwiw, I committed some safer rpath handling code master/ branch as 0.7.1-5.

I'd suggest merging those changes into other branches, and include new/fixed builds in the proposed update here.

Comment 8 Peter Robinson 2011-03-16 03:18:05 UTC
(In reply to comment #7)
> Fwiw, I committed some safer rpath handling code master/ branch as 0.7.1-5.
> 
> I'd suggest merging those changes into other branches, and include new/fixed
> builds in the proposed update here.

Thanks Rex, I'd missed the point about the rpaths in the midst of all the BZ emails, I'll update the update with new builds.

Comment 9 Fedora Update System 2011-03-23 01:52:26 UTC
speech-dispatcher-0.7.1-5.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-5.fc14

Comment 10 Fedora Update System 2011-03-23 01:52:35 UTC
speech-dispatcher-0.7.1-5.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-5.fc13

Comment 11 Fedora Update System 2011-03-23 22:54:02 UTC
speech-dispatcher-0.7.1-4.fc13, dotconf-1.3-2.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2011-03-23 22:55:53 UTC
speech-dispatcher-0.7.1-4.fc14, dotconf-1.3-2.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 Kevin Kofler 2011-03-23 23:35:04 UTC
As discussed above, this is NOT fixed by 0.7.1-4, reopening.

Comment 14 Peter Robinson 2011-03-24 00:57:29 UTC
(In reply to comment #13)
> As discussed above, this is NOT fixed by 0.7.1-4, reopening.

As discussed above I've pushed build 5 to fix this and if you read to the above its in testing. bodhi for some reason wouldn't let me edit the build to replace 4 with 5 so I pushed -4 to stable and once it was pending added -5 to it which you can see above and if you check bodhi is there. No idea why bodhi was being painful and frankly I don't have the time to care.

Comment 15 Kevin Kofler 2011-03-24 01:10:22 UTC
I have seen this, and I have indeed put the bug into the correct state (ON_QA) and set the "Fixed In Version" field correctly.

To make this clear for everyone:

speech-dispatcher-0.7.1-5.fc1[34] is currently in the Fedora 13 resp. 14 updates-testing repository and can be installed with:
su -c "yum --enablerepo=updates-testing update speech-dispatcher"

0.7.1-4 does not fix this bug. 0.7.1-5 does.

Comment 16 Fernando Herrera 2011-03-24 01:57:53 UTC
Thanks guys.

I have tested fc14 0.7.1-5 packages from:
http://koji.fedoraproject.org/koji/buildinfo?buildID=234034

and it fixes it.

Comment 17 Peter Robinson 2011-03-24 02:27:53 UTC
(In reply to comment #16)
> Thanks guys.
> 
> I have tested fc14 0.7.1-5 packages from:
> http://koji.fedoraproject.org/koji/buildinfo?buildID=234034
> 
> and it fixes it.

Please add appropriate karma to the update https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-5.fc14

Comment 18 Fernando Herrera 2011-03-24 02:41:55 UTC
(In reply to comment #17)
> (In reply to comment #16)
> > Thanks guys.
> > 
> > I have tested fc14 0.7.1-5 packages from:
> > http://koji.fedoraproject.org/koji/buildinfo?buildID=234034
> > 
> > and it fixes it.
> 
> Please add appropriate karma to the update
> https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-5.fc14

I'm sorry, but after 8 attempts of getting the captcha right at admin.fedoraproject.org, I'm giving up. The karma for the packages is ok. the karma for the account creation system is not (nor accessible)

Comment 19 Peter Robinson 2011-03-24 02:46:55 UTC
> > Please add appropriate karma to the update
> > https://admin.fedoraproject.org/updates/speech-dispatcher-0.7.1-5.fc14
> 
> I'm sorry, but after 8 attempts of getting the captcha right at
> admin.fedoraproject.org, I'm giving up. The karma for the packages is ok. the
> karma for the account creation system is not (nor accessible)

No problems and thanks for the feedback for the karma system, I'll open a ticket with the relevant package to see if we can get it improved.

Comment 20 Fedora Update System 2011-04-05 05:18:25 UTC
speech-dispatcher-0.7.1-5.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2011-04-05 05:19:22 UTC
speech-dispatcher-0.7.1-5.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.